' Lemmings Functions - Graphics Tool
' Footer File
' by Namida Verasche
' see lf_gfx_head.bas for info

SUB lfg_patch_xmas
for x = 0 to 15
  lfg_default_low8(x).ega_value = lfg_default_low8_xmas(x).ega_value
  lfg_default_low8(x).vga_red = lfg_default_low8_xmas(x).vga_red
  lfg_default_low8(x).vga_blue = lfg_default_low8_xmas(x).vga_blue
  lfg_default_low8(x).vga_green = lfg_default_low8_xmas(x).vga_green
  lfg_menu_pal(x).ega_value = lfg_menu_pal_xmas(x).ega_value
  lfg_menu_pal(x).vga_red = lfg_menu_pal_xmas(x).vga_red
  lfg_menu_pal(x).vga_blue = lfg_menu_pal_xmas(x).vga_blue
  lfg_menu_pal(x).vga_green = lfg_menu_pal_xmas(x).vga_green
  if x < 8 then
    lfg_hppc_hipal(x).ega_value = lfg_hppc_xhipal(x).ega_value
    lfg_hppc_hipal(x).vga_red = lfg_hppc_xhipal(x).vga_red
    lfg_hppc_hipal(x).vga_blue = lfg_hppc_xhipal(x).vga_blue
    lfg_hppc_hipal(x).vga_green = lfg_hppc_xhipal(x).vga_green
  end if
next
END SUB

SUB lfg_set_rgb24(e, r, g, b)
  lfg_active_pallete(e).vga_red = int(r / 4)
	lfg_active_pallete(e).vga_green = int(g / 4)
	lfg_active_pallete(e).vga_blue = int(b / 4)
end sub
	

SUB lfg_reset_low8
FOR x = 0 TO 15
  lfg_active_pallete(x).ega_value = lfg_default_low8(x).ega_value
  lfg_active_pallete(x).vga_red = lfg_default_low8(x).vga_red
  lfg_active_pallete(x).vga_green = lfg_default_low8(x).vga_green
  lfg_active_pallete(x).vga_blue = lfg_default_low8(x).vga_blue
NEXT x
END SUB

SUB lfg_use_menu_pal
FOR x = 0 TO 15
  lfg_active_pallete(x).ega_value = lfg_menu_pal(x).ega_value
  lfg_active_pallete(x).vga_red = lfg_menu_pal(x).vga_red
  lfg_active_pallete(x).vga_green = lfg_menu_pal(x).vga_green
  lfg_active_pallete(x).vga_blue = lfg_menu_pal(x).vga_blue
NEXT
END SUB

sub lfg_set_hppc_hipal
for x = 8 to 15
  lfg_active_pallete(x).ega_value = lfg_hppc_hipal(x-8).ega_value
  lfg_active_pallete(x).vga_red = lfg_hppc_hipal(x-8).vga_red
  lfg_active_pallete(x).vga_green = lfg_hppc_hipal(x-8).vga_green
  lfg_active_pallete(x).vga_blue = lfg_hppc_hipal(x-8).vga_blue
NEXT
END SUB 

'sub lfg_set_hppc_xhipal
'for x = 8 to 15
'  lfg_active_pallete(x).ega_value = lfg_hppc_xhipal(x-8).ega_value
'  lfg_active_pallete(x).vga_red = lfg_hppc_xhipal(x-8).vga_red
'  lfg_active_pallete(x).vga_green = lfg_hppc_xhipal(x-8).vga_green
'  lfg_active_pallete(x).vga_blue = lfg_hppc_xhipal(x-8).vga_blue
'NEXT
'END SUB 

FUNCTION lfg_rgba (inpal AS lfg_pallete_entry)
red = inpal.vga_red * 4
green = inpal.vga_green * 4
blue = inpal.vga_blue * 4
alpha = 255
lfg_rgba = _RGBA32(red, green, blue, alpha)
END FUNCTION

SUB lfg_palent (incol AS LONG)
red = _RED32(incol)
green = _GREEN32(incol)
blue = _BLUE32(incol)
lfg_out_pal.vga_red = INT(red / 4)
lfg_out_pal.vga_green = INT(green / 4)
lfg_out_pal.vga_blue = INT(blue / 4)
lfg_out_pal.ega_value = lfg_ega_color(red, green, blue)
END SUB
  
FUNCTION lfg_ega_color (vred, vgreen, vblue)
ered = INT(vred / 64)
egreen = INT(vgreen / 64)
eblue = INT(vblue / 64)
o = 0
IF ered > 1 THEN o = o + 32
IF egreen > 1 THEN o = o + 16
IF eblue > 1 THEN o = o + 8
IF ered = 1 OR ered = 3 THEN o = o + 4
IF egreen = 1 OR egreen = 3 THEN o = o + 2
IF eblue = 1 OR eblue = 3 THEN o = o + 1
lfg_ega_color = o
END FUNCTION

sub lfg_input_pallete_array (arry() as _UNSIGNED _BYTE)
  for x = 0 to 7
    lfg_active_pallete(x + 8).ega_value = arry(x)
  next
  for x = 0 to 7
    lfg_active_pallete(x).ega_value = arry(x+8)
  next
  nb = 24
  for x = 0 to 7
    lfg_active_pallete(x + 8).vga_red = arry(nb)
	lfg_active_pallete(x + 8).vga_green = arry(nb + 1)
	lfg_active_pallete(x + 8).vga_blue = arry(nb + 2)
    nb = nb + 3
  next
  for x = 0 to 7
    lfg_active_pallete(x).vga_red = arry(nb)
	lfg_active_pallete(x).vga_green = arry(nb + 1)
	lfg_active_pallete(x).vga_blue = arry(nb + 2)
    nb = nb + 3
  next
end sub

SUB lfg_output_pallete_array (arry() AS _UNSIGNED _BYTE)
REDIM arry(95) AS _UNSIGNED _BYTE
FOR x = 0 TO 7
  arry(x) = lfg_active_pallete(x + 8).ega_value
NEXT
FOR x = 0 TO 7
  arry(x + 8) = lfg_active_pallete(x).ega_value
NEXT
FOR x = 0 TO 7
  arry(x + 16) = lfg_active_pallete(x + 8).ega_value
NEXT
nb = 24
FOR x = 0 TO 7
  arry(nb) = lfg_active_pallete(x + 8).vga_red
  arry(nb + 1) = lfg_active_pallete(x + 8).vga_green
  arry(nb + 2) = lfg_active_pallete(x + 8).vga_blue
  nb = nb + 3
NEXT
FOR x = 0 TO 7
  arry(nb) = lfg_active_pallete(x).vga_red
  arry(nb + 1) = lfg_active_pallete(x).vga_green
  arry(nb + 2) = lfg_active_pallete(x).vga_blue
  nb = nb + 3
NEXT
FOR x = 0 TO 7
  arry(nb) = lfg_active_pallete(x + 8).vga_red
  arry(nb + 1) = lfg_active_pallete(x + 8).vga_green
  arry(nb + 2) = lfg_active_pallete(x + 8).vga_blue
  nb = nb + 3
NEXT
END SUB

SUB lfg_set_ega_from_vga
FOR x = 0 TO 15
  ered = INT(lfg_active_pallete(x).vga_red / 16)
  egreen = INT(lfg_active_pallete(x).vga_green / 16)
  eblue = INT(lfg_active_pallete(x).vga_blue / 16)
  o = 0
  IF ered > 1 THEN o = o + 32
  IF egreen > 1 THEN o = o + 16
  IF eblue > 1 THEN o = o + 8
  IF ered = 1 OR ered = 3 THEN o = o + 4
  IF egreen = 1 OR egreen = 3 THEN o = o + 2
  IF eblue = 1 OR eblue = 3 THEN o = o + 1
  lfg_active_pallete(x).ega_value = o
NEXT
END SUB

SUB lfg_set_pallete_from_image (inum)
FOR x = 0 TO 15
  lfg_active_pallete(x).vga_red = int(lfc_get_pixel_red(inum, x, 0) / 4)
  lfg_active_pallete(x).vga_green = int(lfc_get_pixel_green(inum, x, 0) / 4)
  lfg_active_pallete(x).vga_blue = int(lfc_get_pixel_blue(inum, x, 0) / 4)
NEXT
lfg_set_ega_from_vga
END SUB

SUB lfg_set_pallete_entry (entnum, palent AS lfg_pallete_entry)
lfg_active_pallete(entnum).vga_red = palent.vga_red
lfg_active_pallete(entnum).vga_green = palent.vga_green
lfg_active_pallete(entnum).vga_blue = palent.vga_blue
lfg_active_pallete(entnum).ega_value = palent.ega_value
END SUB

FUNCTION lfg_extract_image_mask (width, height, filenum, posit, maskloc, depth)
k = lfg_extract_image(width, height, filenum, posit, depth)
lfg_apply_mask k, width, height, filenum, maskloc
END FUNCTION
  
FUNCTION lfg_extract_image (width, height, filenum, posit, depth)
k = lfc_new_image(width, height)
DIM paltab(width - 1, height - 1) AS _UNSIGNED LONG
cbit = 7
cbyte = 0
FOR rep = 0 TO (depth - 1)
  FOR y = 0 TO height - 1
    FOR x = 0 TO width - 1
      n = lfc_get_byte(filenum, posit + cbyte)
      IF n AND 2 ^ cbit THEN paltab(x, y) = paltab(x, y) + 2 ^ rep
      cbit = cbit - 1
      IF cbit = -1 THEN
        cbit = 7
        cbyte = cbyte + 1
      END IF
    NEXT
  NEXT
NEXT
DIM c AS _UNSIGNED LONG
FOR y = 0 TO height - 1
  FOR x = 0 TO width - 1
	  if depth < 18 then
      lfg_set_pixel_pal k, x, y, lfg_active_pallete(paltab(x, y))
		else
		  c = paltab(x, y)
			b = c mod 64
			g = int(c / 64) mod 64
			r = int(c / (64 * 64)) mod 64
			a = int(c / (64 * 64 * 64))
		  lfc_set_pixel k, x, y, r*4, g*4, b*4
			if depth = 19 and a = 0 then lfc_set_pixel k, x, y, 255, 0, 255
    end if			
  NEXT
NEXT
lfg_extract_image = k
END FUNCTION

FUNCTION lfg_encode_image (inum, filenum, posit, depth, mode)
width = lfc_images(inum, 0)
height = lfc_images(inum, 1)
DIM paltab(width - 1, height - 1) AS _UNSIGNED LONG
DIM putcol as _unsigned long
FOR y = 0 TO height - 1
  FOR x = 0 TO width - 1
    tr = INT(lfc_get_pixel_red(inum, x, y) / 4)
    tg = INT(lfc_get_pixel_green(inum, x, y) / 4)
    tb = INT(lfc_get_pixel_blue(inum, x, y) / 4)
		if depth < 18 then
			putcol = -1
			FOR palmatch = 0 TO 15
				IF tr = lfg_active_pallete(palmatch).vga_red AND tg = lfg_active_pallete(palmatch).vga_green AND tb = lfg_active_pallete(palmatch).vga_blue THEN
					putcol = palmatch
					EXIT FOR
				END IF
			NEXT
			IF putcol = -1 THEN
				putcol = 0
			ELSE
				IF mode = 1 THEN putcol = 1
			END IF
		else
		  putcol = tb + (tg * 64) + (tr * 64 * 64)
			if depth = 19 and (lfc_get_pixel_red(inum, x, y) <> 255 or lfc_get_pixel_green(inum, x, y) <> 0 or lfc_get_pixel_blue(inum, x, y) <> 255) then
			  putcol = putcol + (64 * 64 * 64)
			else
			  putcol = 0
			end if
		end if
		paltab(x, y) = putcol
  NEXT
NEXT
cbit = 7
cbyte = posit
n = 0
FOR rep = 0 TO (depth - 1)
  FOR y = 0 TO height - 1
    FOR x = 0 TO width - 1
      IF paltab(x, y) AND 2 ^ rep THEN n = n + 2 ^ cbit
      cbit = cbit - 1
      IF cbit = -1 THEN
        lfc_put_byte filenum, cbyte, n
        cbyte = cbyte + 1
        cbit = 7
        n = 0
      END IF
    NEXT
  NEXT
NEXT
lfg_encode_image = cbyte
END FUNCTION

SUB lfg_apply_mask (k, width, height, filenum, posit)
cbit = 7
cbyte = 0
FOR y = 0 TO height - 1
  FOR x = 0 TO width - 1
    n = lfc_get_byte(filenum, posit + cbyte)
    IF n AND 2 ^ cbit = 0 THEN lfc_set_pixel k, x, y, 255, 0, 255
  NEXT
NEXT
END SUB

SUB lfg_set_pixel_pal (inum, x, y, palt AS lfg_pallete_entry)
lfc_set_pixel inum, x, y, palt.vga_red * 4, palt.vga_green * 4, palt.vga_blue * 4
END SUB

FUNCTION lfg_extract_image_multi (width, height, filenum, posit, maskoff, gap, frames, depth)
t = lfc_new_image(width, height * frames)
FOR doframe = 0 TO (frames - 1)
  k = lfg_extract_image(width, height, filenum, posit, depth)
  posit = posit + gap
  lfc_clone_image k, t, 0, (doframe * height)
  lfc_close_image k
NEXT
lfg_extract_image_multi = t
END FUNCTION
